#!/usr/bin/env python
# coding: utf-8


import sys
import pandas as pd
import numpy as np
import os, sys, re
from sklearn.decomposition import PCA
from sklearn.externals import joblib
import math
import argparse
from sklearn.preprocessing import MinMaxScaler
import re
dimnum  = r"10"

file4 = open('./in/userinput.txt','r',encoding='utf-8')#输入格式为，第一行仅id，下一行接序列
seq4 = pd.read_csv(file4,header=None)
seqs4 =seq4.values.tolist()

out4 = open(r"./in/pmp.txt",'w',encoding='utf-8')#输出文件位置
for i in range(len(seqs4)):
    if seqs4[i][0][0] == ">":
        res4_id=seqs4[i][0]+"|0|testing"
        out4.write("".join(res4_id)+'\n')   
    else:
        res4_seq=seqs4[i]
        out4.write("".join(res4_seq)+'\n')
out4.close() 
print("Pretreatment completed") 
   
##############################
def read_csv(file):
    encodings = []
    labels = []
    with open(file) as f:
        records = f.readlines()
    ##
    feature = 1
    header = ['#']
    for i in range(1, len(records[0].split(','))):
        header.append('f.%d' % feature)
        feature = feature + 1
    encodings.append(header)
    ##
    sample = 1
    for line in records:
        array = line.strip().split(',') if line.strip() != '' else None
        encodings.append(['s.%d' % sample] + array[1:])
        labels.append(int(array[0]))
        sample = sample + 1
    return np.array(encodings), labels

def write_to_csv(encodings, file):
    with open(file, 'w') as f:
        for line in encodings[1:]:
            line = line[1:]
            f.write('%s' % line[0])
            for i in range(1, len(line)):
                f.write(',%s' % line[i])
            f.write('\n')
            
def save_reduction_result(reduced_data, file='dimension_reduction.txt'):
    with open(file, 'w') as f:
        for i in reduced_data:
            f.write(i[0])
            for j in range(1, len(i)):
                f.write(',' + str(i[j]))
            f.write('\n')
    return None       

#特征选择用的读有表头的csv         
def read_csv1(file):
    encodings = []
    labels = []
    with open(file) as f:
        records = f.readlines()
    ##列
    feature = 1
    header = ['#']
    for i in range(1, len(records[0].split(','))):
       
        header.append('f.%d' % feature)
        feature = feature + 1
    encodings.append(header)
    ##行
    sample = 1
    flg=0
    for line in records:
        #2020619新加跳过第一行表头
        if flg==0:
            flg=1
            continue
        array = line.strip().split(',') if line.strip() != '' else None
        
        encodings.append(['s.%d' % sample] + array[1:])
        labels.append(int(array[0]))
        sample = sample + 1
    return np.array(encodings), labels

def MinMax(encodings, labels):
    normalized_vector = np.zeros((len(encodings), len(encodings[0]) + 1)).astype(str)
    normalized_vector[0, 2:] = encodings[0][1:]
    normalized_vector[:, 0] = encodings[:, 0]
    normalized_vector[:, 1] = ['label'] + labels
    data = np.array(encodings[1:, 1:]).astype(float)
    e = ''
    maxValue = []
    minValue = []
    for i in range(len(data[0])):
        maxValue.append(max(data[:, i])) 
        minValue.append(min(data[:, i]))
        try:
            data[:, i] = (data[:, i] - minValue[i]) / (maxValue[i]- minValue[i])
        except ZeroDivisionError as e:
            return 0, e
    normalized_vector[1:, 2:] = data.astype(str)
    return normalized_vector.tolist(), e, maxValue, minValue

def MinMax2(encodings, labels, maxValue, minValue):
    normalized_vector = np.zeros((len(encodings), len(encodings[0]) + 1)).astype(str)
    normalized_vector[0, 2:] = encodings[0][1:]
    normalized_vector[:, 0] = encodings[:, 0]
    normalized_vector[:, 1] = ['label'] + labels
    data = np.array(encodings[1:, 1:]).astype(float)
    e = ''
    for i in range(len(data[0])):
        try:
            data[:, i] = (data[:, i] - minValue[i]) / (maxValue[i]- minValue[i])
        except ZeroDivisionError as e:
            return 0, e
    normalized_vector[1:, 2:] = data.astype(str)
    return normalized_vector.tolist(), e

def pca(encodings, n_components,k,):
    encodings = np.array(encodings)[1:]
    data = encodings[:, 1:]
    shape = data.shape
    data = np.reshape(data, shape[0] * shape[1])
    data = np.reshape([float(i) for i in data], shape)
    if k == 1:
        #save model
        dimpca=PCA(n_components = n_components).fit(data)
        joblib.dump(dimpca, './model/train_pca.pkl')
        #
        newData = PCA(n_components = n_components).fit_transform(data)
        pca = []
        for i in range(len(data)):
            pca.append([encodings[i][0]] + list(newData[i]))
        return pca
    else:
        #load model
        dimpca = joblib.load('./model/train_pca.pkl')
        newData = dimpca.transform(data)
        #
        pca = []
        for i in range(len(data)):
            pca.append([encodings[i][0]] + list(newData[i]))
        return pca

def calProb(array):
    myProb = {}
    myClass = set(array)
    for i in myClass:
        myProb[i] = array.count(i) / len(array)
    return myProb

binBox = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]

def jointProb(newArray, labels):
    myJointProb = {}
    for i in range(len(labels)):
        myJointProb[str(newArray[i]) + '-' + str(labels[i])] = myJointProb.get(str(newArray[i]) + '-' + str(labels[i]), 0) + 1

    for key in myJointProb:
        myJointProb[key] = myJointProb[key] / len(labels)
    return myJointProb

def IG(encodings, labels):
    features = encodings[0][1:]
    encodings = np.array(encodings)[1:]
    data = encodings[:, 1:]
    shape = data.shape
    data = np.reshape(data, shape[0] * shape[1])
    data = np.reshape([float(i) for i in data], shape)

    e = ''
    if shape[0] < 5 or shape[1] < 2:
        return 0, e

    dataShape = data.shape

    if dataShape[1] != len(features):
        print('Error: inconsistent data shape with feature number.')
        return 0, 'Error: inconsistent data shape with feature number.'

    if dataShape[0] != len(labels):
        print('Error: inconsistent data shape with sample number.')
        return 0, 'Error: inconsistent data shape with sample number.'

    sampleNumber = len(data)
    labelClass = set(labels)
    probY = calProb(labels)
    myFea = {}
    for i in range(len(features)):
        array = data[:, i]
        newArray = list(pd.cut(array, len(binBox), labels= binBox))
        binBoxClass = set(newArray)

        probX = calProb(newArray)
        probXY = jointProb(newArray, labels)
        HX = -1 * sum([p * math.log(p, 2) for p in probX.values()])
        HXY = 0
        for y in probY.keys():
            for x in probX.keys():
                if str(x) + '-' + str(y) in probXY:
                    HXY = HXY + (probXY[str(x) + '-' + str(y)] * math.log(probXY[str(x) + '-' + str(y)] / probY[y], 2))
        myFea[features[i]] = HX + HXY
    res = []
    res.append(['feature', 'IG-value'])
    for key in sorted(myFea.items(), key=lambda item:item[1], reverse=True):
        res.append([key[0], '{0:.3f}'.format(myFea[key[0]])])
    return res, e

    #训练集特征选择
def select_features(encodings, labels, selected_features, selected_feature_number,feature):
    rows = []
    
    for i in range(1, len(selected_features)):
        searchObj = re.search('f\.(\d+)', selected_features[i][0])
        if searchObj:
            rows.append(int(searchObj.group(1)))#这里返回信息熵从到小排列的 索引值
    feature_number = selected_feature_number
    if len(rows) < selected_feature_number:
        feature_number = len(rows)
    rows = [0] + rows
    selected_feature_vectors = np.zeros((len(encodings), feature_number + 2)).astype(str)
    encodings = np.array(encodings)
    selected_feature_vectors[:, 0] = encodings[:, 0]
    labels = np.array(['label'] + labels)
    selected_feature_vectors[:, 1] =labels
    for i in range(1, feature_number + 1):
        selected_feature_vectors[:, i+1] = encodings[:, rows[i]]
    ##将训练集选出来的前select_fea_num列的索引值存入csv,供测试集读取，是新增
    ###1、将选出来的列，删除全0列
    aaa=selected_feature_vectors[1:,2:]
    from sklearn.feature_selection import VarianceThreshold#方差过滤
    selector = VarianceThreshold()#不填参数，默认方差为0
    x_var0 = selector.fit_transform(aaa)#得到新的特征矩阵
    # 保留特征名称
    all_name =selected_feature_vectors[0,2:].tolist()  # 获得所有的特征名称
    select_name_index0 = selector.get_support(indices=True)  # 留下特征的索引值，list格式
    select_name0 = []
    for i in select_name_index0:
        select_name0.append(all_name[i])
    name = np.array(select_name0)
    name = name[:,np.newaxis]
    data = np.concatenate((name.T,x_var0),axis=0) 
#   print(data) 
   ####删除全0列结束  
    selected_column = []
    for i in range(2, len(selected_feature_vectors[0])):
        searchObj2 = re.search('f\.(\d+)', selected_feature_vectors[0][i])
        if searchObj2:
            selected_column.append(int(searchObj2.group(1)))
    pd.DataFrame(selected_column).to_csv('./model/%s_IG.csv'%feature, index=False,header=None)
    #存入CSV结束
    return selected_feature_vectors

# 测试集特征选择
def select_features1(encodings, labels, selected_feature_number,column):
    rows = column
    feature_number = selected_feature_number
    if len(rows) < selected_feature_number:
        feature_number = len(rows)
    rows = [0] + rows
    selected_feature_vectors = np.zeros((len(encodings), feature_number + 2)).astype(str)
    encodings = np.array(encodings)
    selected_feature_vectors[:, 0] = encodings[:, 0]
    labels = np.array(['label'] + labels)
    selected_feature_vectors[:, 1] =labels
    for i in range(1, feature_number + 1):
        selected_feature_vectors[:, i+1] = encodings[:, rows[i]]
    return selected_feature_vectors

def text_save(content,filename,mode='a'):
    # Try to save a list variable in txt file.
    file = open(filename,mode)
    file.truncate(0)#
    for i in range(len(content)):
        file.write(str(content[i])+'\n')
    file.close()
def text_read(filename):
    # Try to read a txt file and return a list.Return [] if there was a mistake.
    try:
        file = open(filename,'r')
    except IOError:
        error = []
        return error
    content = file.readlines()

    for i in range(len(content)):
        content[i] = float(content[i][:len(content[i])-1])
    file.close()
    return content



##############################
############################# 
def testset(feature,select_fea_num):
  #2.1、测试集特征生成
    cmd4 = r"python .\iLearn-master\iLearn-protein-basic.py  --file .\in\pmp.txt --method %s --out  .\out\%s_IND.csv --format csv " %(feature,feature)
    os.system(cmd4)

#     #2.2、特征选择
    encodings6, labels6 = read_csv1('./out/%s_IND.csv'%feature)
    selected_features2, e = IG(encodings6, labels6)
    column_data= pd.read_csv('./model/%s_IG.csv'%feature,header=None)
    column =[]
    dict_test = np.array(column_data)
    list_count = dict_test.tolist()
    for i in list_count:
        column.append(i[0])
    selected_feature_vectors = select_features1(encodings6, labels6, int(select_fea_num),column)
    write_to_csv(selected_feature_vectors.tolist(), './out/%s_IND_IG.csv'%feature)
    
#     #2.4、归一化
    encodings2, labels2 = read_csv('./out/%s_IND_IG.csv'%feature)
    maxValue = text_read('./model/%s_max.txt'%feature)
    minValue = text_read('./model/%s_min.txt'%feature)
    normalized_feature_vectors2, e2=MinMax2(encodings2, labels2,maxValue, minValue)
    write_to_csv(normalized_feature_vectors2,'./out/%s_IND_normalization.csv'%feature)
    
    #2.5、降维（新加的）
    encodings4, labels4 = read_csv('./out/%s_IND_normalization.csv'%feature)
    reduced_data = []
    reduced_data = pca(encodings4,10,0)  #训练集走1，测试集走0
    save_reduction_result(reduced_data, './out/%s_IND_dimension.csv'%feature)
    #将降维结果第一列改为标签列
    df8 = pd.read_csv(r".\out\%s_IND_IG.csv"%feature,  header=None)   
    df8 = df8.iloc[:,0]    
    df9 = pd.read_csv(r".\out\%s_IND_dimension.csv"%feature,  header=None) 
    df9 = df9.iloc[:,1:]
    df10 = pd.concat([df8,df9],join="inner",axis=1)
    df10.to_csv(r".\out\%s_IND_dimension.csv"%feature, index=False,header=None)

    cmd10 = r"python .\iLearn-master\XGBoost.py --train .\out\%s_dimension.csv --indep .\out\%s_IND_dimension.csv  --out  .\out\result --fold 5 --format csv"%(feature,feature)
    os.system(cmd10)
    
testset('TPC',438)  


file2 = open('./in/userinput.txt','r',encoding='utf-8')#输入文件位置
seq = pd.read_csv(file2,header=None)
seqs =seq.values.tolist()
resid = []

for i in range(len(seqs)):
    if seqs[i][0][0] == ">":
        res_str=seqs[i][0].split('>')
        res_str1= res_str[1:]
        resid.append(res_str1)
        

file2.close() 
file3 = open('./out/result_IND.txt','r',encoding='utf-8')#输入文件位置
res_pres = pd.read_csv(file3,header=None)
res_pres = res_pres.values.tolist()[0:]
resvalue=[]

for i in range(len(res_pres)):
    res_pre=res_pres[i][0].split('\t')
    res_pre= res_pre[1:]
    resvalue.append(res_pre)
    
    
#######合并value和ID并判断non/pmp
result=[]
# print(resvalue)
# print(resid)
for i in range(len(resid)):
    resvalues=float(resvalue[i][0])
    if resvalues >= 0 and  resvalues < 0.5:
        res=resid[i][0]+'\t'+resvalue[i][0]+'\t'+'non_PMP'
    else:
        res=resid[i][0]+'\t'+resvalue[i][0]+'\t'+'PMP'
    result.append(res)
# print(result)
file3.close()
out2 = open('./out/result.txt','w',encoding='utf-8')#输出文件位置
for i in range(len(result)):
    s = str(result[i]).replace('[','').replace(']','')#去除[],这两行按数据不同，可以选择
    s = s.replace("'",'').replace(',','') +'\n' #去除单引号，逗号，每行末尾追加换行符
    out2.write(s)         
out2.close() 
print("success")

